// mozctlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mozctl.h"
#include "mozctlDlg.h"

#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMozctlDlg dialog

CMozctlDlg::CMozctlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMozctlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMozctlDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMozctlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMozctlDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_EDIT, m_Url);
	DDX_Control(pDX, IDC_MOZILLA, m_Mozilla);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMozctlDlg, CDialog)
	//{{AFX_MSG_MAP(CMozctlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_FORWARD, OnForward)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_GO, OnGo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMozctlDlg message handlers

BOOL CMozctlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//NETDEMON added this
	m_Mozilla.GoHome();
	SetWindowText("Mozilla Control Test - [NONE]");	

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMozctlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMozctlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMozctlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMozctlDlg::OnAbout() 
{
	// NETDEMON put this in
	CAboutDlg about;
	about.DoModal();
}

BEGIN_EVENTSINK_MAP(CMozctlDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMozctlDlg)
	ON_EVENT(CMozctlDlg, IDC_MOZILLA, 106 /* DownloadBegin */, OnDownloadBeginMozilla, VTS_NONE)
	ON_EVENT(CMozctlDlg, IDC_MOZILLA, 113 /* TitleChange */, OnTitleChangeMozilla, VTS_BSTR)
	ON_EVENT(CMozctlDlg, IDC_MOZILLA, 102 /* StatusTextChange */, OnStatusTextChangeMozilla, VTS_BSTR)
	ON_EVENT(CMozctlDlg, IDC_MOZILLA, 108 /* ProgressChange */, OnProgressChangeMozilla, VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMozctlDlg::OnDownloadBeginMozilla() 
{
	//Change the URL box
	CWnd* pWnd = GetDlgItem(IDC_EDIT);
	pWnd->SetWindowText(m_Mozilla.GetLocationURL());

	//Change the title
	
}

void CMozctlDlg::OnTitleChangeMozilla(LPCTSTR Text) 
{
	// TODO: Add your control notification handler code here
	char title[1000];
	strcpy(title, "Mozilla Control Test - [");
	strcat(title, Text);
	strcat(title, "]");
	SetWindowText(title);	
}

void CMozctlDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	m_Mozilla.Stop();	//Stop Load
}

void CMozctlDlg::OnForward() 
{
	// TODO: Add your control notification handler code here
	m_Mozilla.GoForward();	//Go Forward
	
}

void CMozctlDlg::OnBack() 
{
	// TODO: Add your control notification handler code here
	m_Mozilla.GoBack();	//Go Back
	
}

void CMozctlDlg::OnRefresh() 
{
	// TODO: Add your control notification handler code here
	m_Mozilla.Refresh();
}



void CMozctlDlg::OnStatusTextChangeMozilla(LPCTSTR Text) 
{
	// TODO: Add your control notification handler code here
	CWnd* pWnd = GetDlgItem(IDC_STATUS);
	pWnd->SetWindowText(Text);
	
}



void CMozctlDlg::OnGo() 
{
	// TODO: Add your control notification handler code here
	CString cURL;
	CWnd* pWnd = GetDlgItem(IDC_STATUS);	
	pWnd->GetWindowText(cURL);
	BSTR bstrURL = cURL.AllocSysString();
	m_Mozilla.Navigate((LPCSTR)bstrURL, NULL, NULL, NULL, NULL);
	::SysFreeString(bstrURL);
	//http://msdn.microsoft.com/workshop/browser/webbrowser/reference/IFaces/IWebBrowser2/Navigate2.asp
}

void CMozctlDlg::OnProgressChangeMozilla(long Progress, long ProgressMax) 
{
	// TODO: Add your control notification handler code here
	m_Progress.SetRange32(0, (int)ProgressMax);
	m_Progress.SetPos((int)Progress);
	
}
